//LADDER STUFF

//still on ladder?
if onLadder && !place_meeting(x,y,oLadder)
  onLadder=false
  
//get on ladder climbing up
if place_meeting(x,y,oLadder) && place_meeting(x,y+1,oWall) 
  if keyboard_check(vk_up) 
    onLadder=true
    
//get on ladder climbing down
if place_meeting(x,y+1,oLadder)
  if keyboard_check(vk_down)
    onLadder=true
  
//climbing up ladder
if onLadder && keyboard_check(vk_up){
  y=y-3
  if !place_meeting(x,y,oLadder) {
    onLadder=false
    while(!place_meeting(x,y+1,oLadder))
      y+=1
  } 
}

//climb down ladder?
if onLadder && keyboard_check(vk_down) {
   var wallId, itsOK;
   itsOK=false
   wallId=instance_place(x,y+3,oWall)
   if wallId<0
      y+=3
   else{
      with wallId {
        itsOK=position_meeting(x,y,oLadder)
      }   
      if itsOK==true
          y+=3  
      else{
          while(!place_meeting(x,y+1,oWall))
            y+=1
          onLadder=false
      } 
   } 
}

  
//wall sticking?  remember to set vy=0!
wallSticking=false;
if !place_meeting(x,y+1,oWall){
  if place_meeting(x-1,y,oWall) || place_meeting(x+1,y,oWall) {    
    wallSticking=true
    vy=0
    doubleJump=0
    if keyboard_check(vk_up){   //move up if possible, if not move to contact
       if !place_meeting(x,y-2,oWall)
         y-=2     
       else 
         while(!place_meeting(x,y-1,oWall))
           y-=1
    }
    if keyboard_check(vk_down) {  //move down if possible, if not move to contact 
       if !place_meeting(x,y+4,oWall)
         y+=4
       else 
         while(!place_meeting(x,y+1,oWall))
           y+=1 
    }
  }    
}

//apply gravity
if !place_meeting(x,y+1,oWall) && onLadder==false && !wallSticking {
  vy+=GRAVITY   
  if vy>=12
    vy=12
}


//jump?
if keyboard_check_pressed(vk_control) {
  if place_meeting(x,y+1,oWall){
    vy=-9 
    doubleJump=true
    }
  else if doubleJump {
    vy=-7
    doubleJump=false
  }
}

  
//Y DIRECTION MOVEMENT
if !place_meeting(x,y+vy,oWall)
  y+=vy
else {
  while( !place_meeting(x,y+sign(vy),oWall) )
    y+=sign(vy)
  vy=0
}
  
  
//X DIRECTION MOVEMENT

//keyboard input
var xd;
xd=0
if keyboard_check(vk_right)
 xd+=7
if keyboard_check(vk_left)
 xd-=7

 
//try to move left or right if no wall in your destination position
if !place_meeting(x+xd,y,oWall)
    x+=xd
else {
    //move to the contact point of the wall one pixel at a time
    while( !place_meeting(x+sign(xd),y,oWall) )
      x+=sign(xd)
}

